local AddonName, AddonTable = ...
local L = AddonTable.Localize
local AddonTitle = select(2, GetAddOnInfo(AddonName))
local PlainAddonTitle = AddonTitle:gsub("|c........", ""):gsub("|r", "")

local GTOptions = CreateFrame("Frame")
GTOptions:RegisterEvent("ADDON_LOADED")
GTOptions:RegisterEvent("VARIABLES_LOADED")

local function GTOptionsHandler(self, event, arg1)

if event == "VARIABLES_LOADED" then
	if IsAddOnLoaded("GuildTradeskills") == true then
		SlashCmdList["GTCONFIG"] = gtconfiguration;
			SLASH_GTCONFIG1 = "/gtool"
			
		DEFAULT_CHAT_FRAME:AddMessage("|cFF0088FF[Guild Tooltip]|r GuildTooltip has detected that you are also using the Guild Tradeskills addon; to prevent interference, the command to access GuildTooltip's options window has been changed to /gtool.")
	elseif IsAddOnLoaded("GuildTradeskills") == false then
		SlashCmdList["GTCONFIG"] = gtconfiguration;
			SLASH_GTCONFIG1 = "/gt"
	end
end

end

GTOptions:SetScript("OnEvent", GTOptionsHandler)

-- INTERFACE OPTIONS

local GTIOFrame = CreateFrame("Frame")
GTIOFrame.name = L["GuildTooltip"]

-- Header

local lblTitle = GTIOFrame:CreateFontString(nil, nil, "GameFontHighlight")
lblTitle:SetFont("Fonts\\FRIZQT__.TTF", 12)
lblTitle:SetPoint("TOPLEFT", GTIOFrame, "TOPLEFT", 12, -12)
lblTitle:SetText(L["GuildTooltip"] .. " v" .. GetAddOnMetadata("GuildTooltip", "Version"))

-- Use Colours

local chkIOUseColours = CreateFrame("CheckButton", nil, GTIOFrame, "OptionsBaseCheckButtonTemplate")
chkIOUseColours:SetPoint("TOPLEFT", lblTitle, "BOTTOMLEFT", 0, -8)

chkIOUseColours:SetScript("OnUpdate", function(frame)
	if GTConfig.Colour == "ENABLED" then
		chkIOUseColours:SetChecked(true)
	elseif GTConfig.Colour == "DISABLED" then
		chkIOUseColours:SetChecked(false)
	end
end)

chkIOUseColours:SetScript("OnClick", function(frame)
local tick = frame:GetChecked()

	if tick == false then
		GTConfig.Colour = 'DISABLED'
	elseif tick == true then
		GTConfig.Colour = 'ENABLED'
	end
end)

local chkIOUseColoursText = GTIOFrame:CreateFontString(nil, nil, "GameFontHighlight")
chkIOUseColoursText:SetPoint("LEFT", chkIOUseColours, "RIGHT", 0, 1)
chkIOUseColoursText:SetText(L["Use colours"])

-- Show Healthbar

local chkIOShowHPBar = CreateFrame("CheckButton", nil, GTIOFrame, "OptionsBaseCheckButtonTemplate")
chkIOShowHPBar:SetPoint("TOPLEFT", chkIOUseColours, "BOTTOMLEFT", 0, -8)

chkIOShowHPBar:SetScript("OnUpdate", function(frame)
	if GTConfig.HealthBar == "ENABLED" then
		chkIOShowHPBar:SetChecked(true)
	elseif GTConfig.HealthBar == "DISABLED" then
		chkIOShowHPBar:SetChecked(false)
	end
end)

chkIOShowHPBar:SetScript("OnClick", function(frame)
local tick = frame:GetChecked()

	if tick == false then
		GTConfig.HealthBar = 'DISABLED'
	elseif tick == true then
		GTConfig.HealthBar = 'ENABLED'
	end
end)

local chkIOShowHPBarText = GTIOFrame:CreateFontString(nil, nil, "GameFontHighlight")
chkIOShowHPBarText:SetPoint("LEFT", chkIOShowHPBar, "RIGHT", 0, 1)
chkIOShowHPBarText:SetText(L["Show healthbar under player tooltips"])

-- Show Titles

local chkIOShowTitles = CreateFrame("CheckButton", nil, GTIOFrame, "OptionsBaseCheckButtonTemplate")
chkIOShowTitles:SetPoint("TOPLEFT", chkIOShowHPBar, "BOTTOMLEFT", 0, -8)

chkIOShowTitles:SetScript("OnUpdate", function(frame)
	if GTConfig.Titles == "ENABLED" then
		chkIOShowTitles:SetChecked(true)
	elseif GTConfig.Titles == "DISABLED" then
		chkIOShowTitles:SetChecked(false)
	end
end)

chkIOShowTitles:SetScript("OnClick", function(frame)
local tick = frame:GetChecked()

	if tick == false then
		GTConfig.Titles = 'DISABLED'
	elseif tick == true then
		GTConfig.Titles = 'ENABLED'
	end
end)

local chkIOShowTitlesText = GTIOFrame:CreateFontString(nil, nil, "GameFontHighlight")
chkIOShowTitlesText:SetPoint("LEFT", chkIOShowTitles, "RIGHT", 0, 1)
chkIOShowTitlesText:SetText(L["Show player titles in tooltips"])

-- Show Realms

local chkIOShowRealms = CreateFrame("CheckButton", nil, GTIOFrame, "OptionsBaseCheckButtonTemplate")
chkIOShowRealms:SetPoint("TOPLEFT", chkIOShowTitles, "BOTTOMLEFT", 0, -8)

chkIOShowRealms:SetScript("OnUpdate", function(frame)
	if GTConfig.Realms == "ENABLED" then
		chkIOShowRealms:SetChecked(true)
	elseif GTConfig.Realms == "DISABLED" then
		chkIOShowRealms:SetChecked(false)
	end
end)

chkIOShowRealms:SetScript("OnClick", function(frame)
local tick = frame:GetChecked()

	if tick == false then
		GTConfig.Realms = 'DISABLED'
	elseif tick == true then
		GTConfig.Realms = 'ENABLED'
	end
end)

local chkShowRealmsText = GTIOFrame:CreateFontString(nil, nil, "GameFontHighlight")
chkShowRealmsText:SetPoint("LEFT", chkIOShowRealms, "RIGHT", 0, 1)
chkShowRealmsText:SetText(L["Show player realms in tooltips"])

-- Show Guild Rank

local chkIOShowGuildRank = CreateFrame("CheckButton", nil, GTIOFrame, "OptionsBaseCheckButtonTemplate")
chkIOShowGuildRank:SetPoint("TOPLEFT", chkIOShowRealms, "BOTTOMLEFT", 0, -8)

chkIOShowGuildRank:SetScript("OnUpdate", function(frame)
	if GTConfig.GuildRank == "ENABLED" then
		chkIOShowGuildRank:SetChecked(true)
	elseif GTConfig.GuildRank == "DISABLED" then
		chkIOShowGuildRank:SetChecked(false)
	end
end)

chkIOShowGuildRank:SetScript("OnClick", function(frame)
local tick = frame:GetChecked()

	if tick == false then
		GTConfig.GuildRank = 'DISABLED'
	elseif tick == true then
		GTConfig.GuildRank = 'ENABLED'
	end
end)

local chkIOShowGuildRankText = GTIOFrame:CreateFontString(nil, nil, "GameFontHighlight")
chkIOShowGuildRankText:SetPoint("LEFT", chkIOShowGuildRank, "RIGHT", 0, 1)
chkIOShowGuildRankText:SetText(L["Show guild rank in tooltips"])

-- Font Size

local lblIOFontSizeText = GTIOFrame:CreateFontString(nil, nil, "GameFontHighlight")
lblIOFontSizeText:SetPoint("TOPLEFT", chkIOShowGuildRank, "BOTTOMLEFT", 0, -8)
lblIOFontSizeText:SetText(L["Tooltip font size:"])

--local ddFontSize = CreateFrame("Frame", "GTFontSize", GTIOFrame, "UIDropDownMenuTemplate")

-- Create the dropdown, and configure its appearance
local ddFontSize = CreateFrame("FRAME", "GTFontSize", GTIOFrame, "UIDropDownMenuTemplate")
ddFontSize:SetPoint("LEFT", lblIOFontSizeText, "RIGHT", 0, 1)
if GetLocale() == "frFR" then
	UIDropDownMenu_SetWidth(ddFontSize, 128)
else
	UIDropDownMenu_SetWidth(ddFontSize, 96)
end
UIDropDownMenu_SetText(ddFontSize, L["Select One"])

-- Create and bind the initialization function to the dropdown menu
UIDropDownMenu_Initialize(ddFontSize, function(self, level, menuList)
local info = UIDropDownMenu_CreateInfo()
	info.func = self.SetValue
	info.text, info.arg1 = "12", 12
	UIDropDownMenu_AddButton(info)
	info.text, info.arg1 = "14", 14
	UIDropDownMenu_AddButton(info)
	info.text, info.arg1 = "16", 16
	UIDropDownMenu_AddButton(info)
	info.text, info.arg1 = "18", 18
	UIDropDownMenu_AddButton(info)
	info.text, info.arg1 = "20", 20
	UIDropDownMenu_AddButton(info)
end)

-- Implement the function to change the font size
function ddFontSize:SetValue(newValue)
	GTConfig.FontSize = newValue
	DEFAULT_CHAT_FRAME:AddMessage("|cFF0088FF[" .. L["GuildTooltip"] .. "]|r " .. L["Font size changed to"] .. " " .. newValue .. ".")
	-- Update the text; if we merely wanted it to display newValue, we would not need to do this
	UIDropDownMenu_SetText(ddFontSize, GTConfig.FontSize)
	-- Because this is called from a sub-menu, only that menu level is closed by default.
	-- Close the entire menu with this next call
	CloseDropDownMenus()
end

-- Discord Info

local DiscordLogo = GTIOFrame:CreateTexture(nil, "ARTWORK")
DiscordLogo:SetPoint("TOPLEFT", chkIOFontSizeText, "BOTTOMLEFT", 0, -16)
DiscordLogo:SetSize(16, 16)
DiscordLogo:SetTexture("Interface\\AddOns\\GuildTooltip\\Textures\\DiscordLogo.tga")

local lblDiscord = GTIOFrame:CreateFontString(nil, nil, "GameFontHighlight")
lblDiscord:SetPoint("LEFT", DiscordLogo, "RIGHT", 4, 0)
lblDiscord:SetText("|cFFEFC502https://discord.gg/BGKnpza|r")

-- Twitter Info

local TwitterLogo = GTIOFrame:CreateTexture(nil, "ARTWORK")
TwitterLogo:SetPoint("TOPLEFT", DiscordLogo, "BOTTOMLEFT", 0, -8)
TwitterLogo:SetSize(16, 16)
TwitterLogo:SetTexture("Interface\\AddOns\\GuildTooltip\\Textures\\TwitterLogo.tga")

local lblTwitter = GTIOFrame:CreateFontString(nil, nil, "GameFontHighlight")
lblTwitter:SetPoint("LEFT", TwitterLogo, "RIGHT", 4, 0)
lblTwitter:SetText("|cFFEFC502@GeodesicDragon|r")

InterfaceOptions_AddCategory(GTIOFrame);

-- Config Sash Command Handler

function gtconfiguration(msg, editbox)

if msg == "" or msg == nil then
	--gtconfig()
	InterfaceOptionsFrame_OpenToCategory(L["GuildTooltip"])
	InterfaceOptionsFrame_OpenToCategory(L["GuildTooltip"])
elseif msg == "help" then
	DEFAULT_CHAT_FRAME:AddMessage("|cFF0088FF[Guild Tooltip]|r The following arguments are valid:\ncolour/color - Toggle colouring of player name and class\nhp/health/bar - Toggle the HP bar under the tooltip\ntitles - Toggle showing of player titles\nrealms - Toggle showing of player realms\ngrank/guildrank - Toggle showing of player guild ranks")
elseif msg == "colour" or msg == "color" then
	if GTConfig.Colour == "ENABLED" then
		GTConfig.Colour = 'DISABLED'
	elseif GTConfig.Colour == "DISABLED" then
		GTConfig.Colour = 'ENABLED'
	end
elseif msg == "hp" or msg == "health" or msg == "bar" then
	if GTConfig.HealthBar == "ENABLED" then
		GTConfig.HealthBar = 'DISABLED'
	elseif GTConfig.HealthBar == "DISABLED" then
		GTConfig.HealthBar = 'ENABLED'
	end
elseif msg == "titles" then
	if GTConfig.Titles == "ENABLED" then
		GTConfig.Titles = 'DISABLED'
	elseif GTConfig.Titles == "DISABLED" then
		GTConfig.Titles = 'ENABLED'
	end
elseif msg == "realms" then
	if GTConfig.Realms == "ENABLED" then
		GTConfig.Realms = 'DISABLED'
	elseif GTConfig.Realms == "DISABLED" then
		GTConfig.Realms = 'ENABLED'
	end
elseif msg == "grank" or msg == "guildrank" then
	if GTConfig.GuildRank == "ENABLED" then
		GTConfig.GuildRank = 'DISABLED'
	elseif GTConfig.GuildRank == "DISABLED" then
		GTConfig.GuildRank = 'ENABLED'
	end
end

end